#include <avr/io.h>
#include <avr/interrupt.h>
#include "ILI9331.h"
#include "ov7670.h"
#include "int.h"
#include <util/delay.h>
#include "FAT.h"
#include "config.h"
#include "mmc_sd.h"
#include "delay.h"

#include <avr/eeprom.h>
#include "ili_lcd_general.h"
#include "lcd_api.h"

#include "i2cmaster.h"

unsigned int image_count = 0, image_all = 0;
// touch init
extern void touch_init(void);
extern void show_toch(void);

extern volatile uint8_t touch_int_flag;

unsigned int twi_array1[] = {0,0,0,0,0,0,0,0};

extern uint16 SectorsPerClust;

extern uint8  FAT32_Enable;

void disp_image(void)
{
    WORD count= 1, i =0;
    uint8 *buffer;
    uint8 type = 0, x = 0, rgb = 0, first = 0, color_byte = 0, byte1 = 0, byte2 = 0, byte3 = 0;
    uint16 y = 0, color = 0, tmp_color = 0;
    uint32 p;				//cluster
    type = 1;
	
	// struct FileInfoStruct FileInfo;
    struct direntry BMPInfo;	//the bmp file item which will be played

    LCD_WR_REG(0x0050, 0);		// horizontal GRAM start point
    LCD_WR_REG(0x0051, 239);	// horizontal GRAM end point
    LCD_WR_REG(0x0052, 0);		// vertical GRAM start point
    LCD_WR_REG(0x0053, 319);	// vertical GRAM end point

    if(image_all == 0)   
    {
        image_count =  0;
        byte1 = Search(&BMPInfo, &image_count, &type);
        image_all = image_count;
        image_count = 1;

        /*
        image_count = 0 ;
        Search(&BMPInfo, &image_count, &type);
        image_all = image_count ;
        GUI_sprintf_chartohex(10, 300, 0x00, 0xffff, 0x0000);
        GUI_sprintf_chartohex(30, 300, image_count, 0xffff, 0x0000);
        GUI_sprintf_chartohex(60, 300, image_all, 0xffff, 0x0000);
        */
    }
    else
    {
        byte1 = Search(&BMPInfo, &image_count, &type);
    }



    p = BMPInfo.deStartCluster + (((uint32)BMPInfo.deHighClust) << 16);	// read the first cluster of the file

    x = 0;
    y = 319;
    rgb = 0;
    count = 0;
    first = 0;
    buffer = malloc(512);
    while(1)
    {
        i = 0;

        for(; i < SectorsPerClust; i++ )      
        {

            FAT_LoadPartCluster(p, i, buffer);	//read a sector

            if(i == 0 && first == 0)
            {
                count = buffer[0x0a];
                color_byte = buffer[0x1c] / 8;
                first = 1;
            }
            else
            {
                count = 0;
            }

            while(count < 512) 
            {

                if(color_byte == 3)   // 24 bit image
                {
                    switch (rgb)
                    {
                    case 0:
                        tmp_color = buffer[count] >> 3;
                        color |= tmp_color;
                        break;

                    case 1:
                        tmp_color = buffer[count] >> 2 ;
                        tmp_color <<= 5;
                        color |= tmp_color;
                        break;

                    case 2:
                        tmp_color = buffer[count] >> 3;
                        tmp_color <<= 11;
                        color |= tmp_color;
                        break;
                    }

                    rgb++;
                }
                else
                {
                    if(color_byte == 2)  // 16 bit image
                    {
                        switch (rgb)
                        {
                        case 0:
                            byte1 = buffer[count];
                            break;

                        case 1:
                            color = buffer[count];
                            color <<= 8;
                            color |= byte1;
                            break;
                        }
                        rgb ++;
                    }
                    else
                    {
                        if(color_byte == 4) // 32 bit image
                        {
                            switch (rgb)
                            {
                            case 0:
                                byte1 = buffer[count];
                                break;

                            case 1:
                                byte2 = buffer[count];
                                break;

                            case 2:
                                byte3 = buffer[count];
                                break;

                            case 3:
                                tmp_color = byte1 >> 3;
                                color |= tmp_color;
                                tmp_color = byte2 >> 2;
                                tmp_color <<= 5;
                                color |= tmp_color;
                                tmp_color = byte3 >>3;
                                tmp_color <<= 11;
                                color |= tmp_color;
                                break;
                            }
                            rgb++;
                        }
                    }
                }

                count++;

                if(rgb == color_byte)
                {
                    // GUI_Point(x, y, color);

                    LCD_WR_REG(0x0020, 239 - x);	// Horizontal GRAM start point of LCD cursor
                    LCD_WR_REG(0x0021, 319 - y); 	// vertical GRAM start point of LCD cursor

                    LCD_WR_REG16(0x0022);
                    LCD_WR_DATA16(color);

                    color = 0x00;
                    x++;
                    if(x >= 240)
                    {
                        y--;
                        if(y<=0)
                        {
                            free(buffer);
                            return;
                        }
                        x = 0;
                    }
                    rgb = 0;
                }
            }
        }  // end of reading a cluster

        free(buffer);
        p=FAT_NextCluster(p);		//read next cluster
        buffer=malloc(512);

        if(p == 0x0fffffff || p == 0x0ffffff8 || (FAT32_Enable == 0 && p == 0xffff))	//no more cluster
        {
            free(buffer);
            return;
        }
    }

    free(buffer);
}




int main(void)
{
    unsigned char retry = 0;
    unsigned int x,y = 0;
   // extern volatile  Key;

    EXCLK_DDR |= 1 << EXCLK_BIT;		// set en_exclk as output
    HC245_OE_DDR |= 1 << HC245_OE_BIT;	// set en_245 as output

    DISEN_EXCLK;	
    DISEN_245;          // !!! Achtung, fr Aktivierung EN_245 nicht vergessen !!!

    DATA_OUPUT(); 
    LCD_Init();   

    //GUI_Point(0, 0, 0xffff);
    LCD_write_english_string(20, 130, "geaenderte Version-erhardd-", RED, BLACK);
    LCD_write_english_string(20, 150, __DATE__, GREEN, BLACK);
    LCD_write_english_string(20, 170, "Atmega32 & ili9325 fuer OV7670 REV4.1", GREEN, BLACK);
    LCD_write_english_string(20, 190, "TF Card Init......", BLUE, BLACK);

    MMC_SD_Init();
    _delay_ms(100);

 


    while(MMC_SD_Reset()&(retry < 5))	
    
    {      
    //sd card initialize
    
        retry++;
        if(retry > 4)
        {
            LCD_write_english_string(20, 190, "TF Card Init...ING", BLUE, BLACK);
            retry = 21;
        }

    }
    if(retry < 20) 
		LCD_write_english_string(20, 190, "TF Card Init....OK", BLUE, BLACK);

    if(retry < 20)
		LCD_write_english_string(20, 210, "FAT Init......", BLUE, BLACK);
		
    while(FAT_Init()&(retry < 20))	//initialize file system  FAT16 and FAT32 are supported
    {
	
    }

    if(retry < 20)
		SearchInit();  

    if(retry < 20) 
		LCD_write_english_string(20, 210, "FAT Init....OK", BLUE, BLACK);


    if(retry>20)
		LCD_write_english_string(20, 210, "OV7670 Init......", BLUE, BLACK);

    while((1 != OV7670_init()) & (retry > 20));
    
	//_delay_ms(1000);
    if(retry > 20)
		LCD_write_english_string(20, 210, "OV7670 Init  0K  ", RED, BLACK);
		
    _delay_ms(200);
	
    if(retry > 20)
		LCD_Clear(0);
    if(retry > 20)
		DATA_INPUT();
    if(retry > 20)
		Init_INT0();


    if(retry < 20)
        {   
            disp_image() ;
            _delay_ms(1000);
            if(image_count < image_all)
            {
                image_count++;
            }
            else
            {
                image_count = 1;
            }
        }


    
//LCD_Paint(2,122,36,76,YELLOW);
/*LCD_Paint(42,122,36,76,MAGENTA);
LCD_Paint(82,122,36,76,BLUE);       // ???
LCD_Paint(120,10,40,60,BLUE);
LCD_Paint(120,160,40,60,MAGENTA);*/
//for(x=0;x<240;x++)GUI_Point(x, 50,RED),GUI_Point(x+1, 50,RED),GUI_Point(x+2, 50,RED);
for(x=0;x<240;x++)GUI_Point(x, 80,RED),GUI_Point(x+1, 80,RED),GUI_Point(x+2, 80,RED);
for(x=0;x<240;x++)GUI_Point(x, 0,RED),GUI_Point(x+1, 0,RED),GUI_Point(x+2, 0,RED);
for(x=0;x<240;x++)GUI_Point(x, 160,RED),GUI_Point(x+1, 160,RED),GUI_Point(x+2, 160,RED);
for(x=0;x<240;x++)GUI_Point(x, 320,RED),GUI_Point(x+1, 320,RED),GUI_Point(x+2, 320,RED);
for(x=0;x<240;x++)GUI_Point(x, 240,RED),GUI_Point(x+1, 240,RED),GUI_Point(x+2, 240,RED);
//for(x=0;x<240;x++)GUI_Point(x, 280,RED),GUI_Point(x+1, 280,RED),GUI_Point(x+2, 280,RED);
for(y=0;y<320;y++)GUI_Point(0,y,RED),GUI_Point( 0,y+1,RED),GUI_Point( 0,y+2,RED);
for(y=0;y<320;y++)GUI_Point(80,y,RED),GUI_Point( 80,y+1,RED),GUI_Point( 80,y+2,RED);
//for(y=0;y<320;y++)GUI_Point(120,y,RED),GUI_Point(120,y+1,RED),GUI_Point(120,y+2,RED);
for(y=0;y<320;y++)GUI_Point(160,y,RED),GUI_Point(160,y+1,RED),GUI_Point(160,y+2,RED);
for(y=0;y<320;y++)GUI_Point(240,y,RED),GUI_Point(240,y+1,RED),GUI_Point(240,y+2,RED);
for(y=0;y<320;y++)GUI_Point(40,y,RED),GUI_Point(40,y+1,RED),GUI_Point(40,y+2,RED);

LCD_Rect(106,142,11,77,WHITE);
//LCD_Rect(84,120,44,120,GREEN);

LCD_Rect(106,142,91,157,WHITE);


LCD_Rect(106,142,171,237,WHITE);


LCD_Rect(106,142,251,317,WHITE);


LCD_Rect(186,222,11,77,WHITE);


LCD_Rect(186,222,91,157,WHITE);


LCD_Rect(186,222,171,237,WHITE);


LCD_Rect(186,222,251,317,WHITE);

     touch_init();
     touch_int_flag = 1;

i2c_init();
		/*twi_array1[0] = (PINA&0b00000001);
		twi_array1[1] = (PINA&0b00000010)>>1;
		twi_array1[2] = (PINA&0b00000100)>>2;
		twi_array1[3] = (PINA&0b00001000)>>3;
        twi_array1[4] = (PINA&0b00010000)>>4;
		twi_array1[5] = (PINA&0b00100000)>>5;
		twi_array1[6] = (PINA&0b01000000)>>6;
        twi_array1[7] = (PINA&0b10000000)>>7;
        */
while(1)
    {
        if( touch_int_flag )
        {
            show_toch();
           
           
        }
       
    }
}

